c****************************************************************************
c Version: 0.1
c Last changed: Mario Monteiro, 2005-02
c This program reads a GONG file with the model from ASTEC in binary format.
c****************************************************************************
	subroutine read_gong (afilein,xin,ndimin,nparin,
     *                        xdata1in,xdata2in,xdata3in,aheaderin)
c
	implicit double precision (b-h,o-z)
	implicit integer (i-n)
	parameter (npt=5000,ncol=40,ndat=200)
	character afilein*80,aheaderin*80
	dimension aheaderin(10)
	dimension xdata1in(ndat),xdata2in(ndat),xdata3in(ndat)
	dimension ndimin(ndat),nparin(ndat),xin(ncol,npt)
c
	common /datasun/sm,sr,sl
c
	open (1,file=afilein,form='unformatted',status='old',err=1100)
c
	read (1,err=1200) (aheaderin(i),i=1,4),
     *           (ndimin(i),i=1,8),
     *		 (xdata1in(i),i=1,ndimin(4)),(nparin(i),i=1,ndimin(5)),
     *		 (xdata2in(i),i=1,ndimin(6)),(xdata3in(i),i=1,ndimin(8)),
     *		 ((xin(i,n),i=1,ndimin(7)),n=1,ndimin(3))
c
	write (*,1040) ndimin(3)
 1040	format ('      Number of mesh points: ',i5)
	write (*,1050) xdata1in(23)/sm,xdata1in(24)/sr,
     *                 xdata1in(25)/sl,xdata2in(3),xdata1in(22)*1.0d-9
 1050	format ('      M/M_sun  = ',f10.4,/,
     *          '      R/R_sun  = ',f10.4,/,
     *          '      L/L_sun  = ',f10.4,/,
     *          '      Teff (K) = ',f10.4,/,
     *          '      Age (Gy) = ',f10.4,/)
c
	close (1)
c
	return
c
 1100	write (*,1110)
 1110	format ('   ERROR: File not available! Please try again:')
	afilein='error'
	return
c
 1200	write (*,1210)
 1210	format ('   ERROR: Unable to read the file! ',
     *          'Please select an adequate one:')
	afilein='error'
	return
c
	end
c**************************************************************************
