c****************************************************************************
c Version: 0.1
c Last changed: Mario Monteiro, 2005-10
c This program reads the output model from STAROX in ascii format.
c****************************************************************************
	subroutine read_srox (afilein,xin,ndimin,xdatain)
c
	implicit double precision (b-h,o-z)
	implicit integer (i-n)
	parameter (npt=5000,ncol=40,ndat=200)
	character afilein*80
	dimension aheaderin(10)
	dimension ndimin(ndat),xin(ncol,npt),xdatain(ndat)
c
	common /datanum/c4pi,cl10
	common /dataphy/cg,csig,cmu
	common /datasun/sm,sr,sl
c
	open (1,file=afilein,form='formatted',status='old',err=1100)
c
c----- Header for Model:
c-> N,Gee,Rs,Ms,dLro2,dLP2,Xc,X0,Z,LLs,Te,age6,qc,xe,alpha,tau
	read (1,*,err=1200) ndimin(1),(xdatain(i),i=1,15)
	ndimin(1)=ndimin(1)+1
c
	write (*,1040) ndimin(1)
 1040	format ('      Number of mesh points: ',i5)
	fac=c4pi*csig
	teff=xdatain(10)
	write (*,1050) xdatain(3)/sm,xdatain(2)/sr,
     *                 xdatain(9),teff,xdatain(11)*1.0d-3
 1050	format ('      M/M_sun  = ',f10.4,/,
     *          '      R/R_sun  = ',f10.4,/,
     *          '      L/L_sun  = ',f10.4,/,
     *          '      Teff (K) = ',f10.4,/,
     *          '      Age (Gy) = ',f10.4,/)
c
c----- Model:
c-> j: x,q,P,rho,Gamma1,D,dq,L,T,nabla_a,nabla_r,nabla,C_p,
c      dlrho/dlt,k,epsilon,X1H,X3He,X4He,X12C,X13C,X14N,X15N,XO16,XO17
	do 10 i=1,ndimin(1)
	   read (1,*,err=1200) xin(ncol,i),(xin(j,i),j=1,25)
 10	continue
c
c----- Header for Evolution:
c-> im,Ms,X0,Z,age6,alpha,tau
c	read (1,*) ndimin(2),(xdatain(i),i=16,20)
cc
c----- Sequence:
c-> j: age,Tei,Li,X1c,Ri,rhoc,Tc,qci,xei
c	do 20 i=1,ndimin(2)
c	   read (1,*) nj,(evin(j,i),j=1,9)
c 20	continue
c
c-------
	close (1)
c
	return
c
 1100	write (*,1110)
 1110	format ('   ERROR: File not available! Please try again:')
	afilein='error'
	return
c
 1200	write (*,1210)
 1210	format ('   ERROR: Unable to read the file! ',
     *          'Please select an adequate one:')
	afilein='error'
	return
c
	end
c**************************************************************************
