c****************************************************************************
c Version: 0.1
c Last changed: Mario Monteiro, 2005-02
c This subroutine sets some basic numerical, physcis and solar constants to
c be used on the otehr subroutines.
c****************************************************************************
	subroutine ref_data
c
	implicit double precision (b-h,o-y)
c
	common /datanum/c4pi,cl10
	common /dataphy/cg,csig,cmu
	common /datasun/sm,sr,sl,sbol
c
c------- Numerical constants:
c 4 pi
	c4pi=16.0d0*atan(1.0d0)
c log(10)
	cl10=log(10.0d0)
c
c------- Physical constants (CGS):
c G
c	cg=6.67232D-8
	cgsm=1.32712438d26
c a
	ca=7.565912199839849d-15
c c
	cc=2.99792458d10
c Sigma
	csig=ca*cc/4.0d0
c m_u
	cmu=1.6605402d-24
c
c------- Solar values (CGS):
c M
        sm=1.98919D+33
c R
	sr=6.9599D+10
c L
	sl=3.846D+33
c M_bol
	sbol=4.75
c------- Others:
	cg=cgsm/sm
c
	return
	end
c****************************************************************************
